
///////////////////////////////////////////////////////
//Asteroid Field (astfield)   -    By Riper
///////////////////////////////////////////////////////


//Feel free to use some of the source code for your game,
//just try to mention where it originally came from

//The base of the game comes from Cave Blaster,  (TIGCC\examples),
//Scroll function from  ExtGraph. Download @ tict.ticalc.org
//Some minor parts from other games, but I cannot recall their names







#define SAVE_SCREEN

#include <string.h>
#include <graph.h>
#include <kbd.h>
#include <system.h>
#include <printf.h>
#include <peekpoke.h>
#include <sprites.h>


short _ti89;

#define ARROWS_ROW 0xfffe      // Constants for low-level keyboard access
#define LEFT_KEY 2
#define RIGHT_KEY 8
#define UP_KEY 1
#define DOWN_KEY 4
#define SECOND_KEY 16
#define ESC_ROW 0xffbf
#define ESC_KEY 1




typedef struct			//stores 1 score
  {
    char name[10];
    unsigned long score;
  } HSC_ITEM;

SCR_RECT screen_area={{0,0,159,99}};

unsigned int rand_seed=0;

void draw_str(int x,int y,char *str)
{
  DrawStr(x,y,str,A_REPLACE);
}


 static char land[]="3";		//global land = speed of game

int xsen=2;	//x and y arrows sensitivity
int ysen=1;


//Graphics - used Sprite Editor from ticalc.org/archives/win/graphics
unsigned int plane[] = { 0x0000, 0x0180, 0x03C0, 0x0180, 0x0180, 0x0180, 0x0180, 0x23C4,
0x27E4, 0x3FFC, 0x3FFC, 0x2244, 0x0000, 0x0000, 0x0000, 0x0000};

//destruction animation - not as well used as in the previous version
unsigned int shipd1[] = { 0x0080, 0x0120, 0x0380, 0x0140, 0x0280, 0x01C0,
0x4110, 0x03C4, 0x27A2, 0x5EFC, 0x376A, 0x0A54, 0x2080, 0x0100, 0x0000, 0x0000};

unsigned int shipm[] = { 0x0000, 0x0040, 0x0020, 0x0040, 0x0040, 0x0040,
 0x0040, 0x0022, 0x0012, 0x0002, 0x0002, 0x0002, 0x0000, 0x0000, 0x0000, 0x0000};

unsigned int shipd2[] = { 0x0280, 0x0010, 0x0580, 0x0120, 0x0240, 0x81C8,
 0x0522, 0x19C8, 0x2321, 0x56DC, 0x3769, 0x0000, 0x1452, 0x4080, 0x0100, 0x0000};

unsigned int shipd3[]= { 0x0488, 0x0200, 0x0890, 0x0140, 0x8A24, 0x1181, 0x20A0, 0x1548,
 0x2121, 0x56DC, 0x2169, 0x0800, 0x2240, 0x1411, 0x8080, 0x0200};

unsigned int shipd4[]= { 0x0488, 0x0200, 0x0890, 0x2144, 0x8A24, 0x1001, 0x2004, 0x1008,
 0x0001, 0x4004, 0x2009, 0x4800, 0x2244, 0x1411, 0x80A2, 0x0208};

unsigned int shipd5[]= { 0x0488, 0x0200, 0x0810, 0x0000, 0x8000, 0x0001, 0x2004, 0x0000,
 0x0001, 0x4000, 0x0001, 0x4000, 0x2004, 0x0001, 0x8022, 0x0208};

unsigned int shipd6[]= { 0x0488, 0x0000, 0x0000, 0x0000, 0x8000, 0x0001, 0x0000, 0x0000,
 0x8001, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x8000, 0x0208};


//ship icon on the bottom of the score bar
static unsigned char lifeicon[]= {0x0, 0x10, 0x10, 0x54, 0x7C, 0x0, 0x0, 0x0};

//static unsigned char mask8[]={ 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
//static unsigned char mask16[]={ 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};

//turn a whole 16x16 pixel area white
unsigned int mask16[]={ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000};

//static unsigned char ast[]={ 0x0, 0x0, 0x3C, 0x7E, 0xFF, 0xFE, 0x7C, 0x30};

//asteroids
static unsigned char ast2[]={ 0x0, 0x38, 0x6C, 0x7A, 0x5C, 0x38, 0x0, 0x0};
static unsigned char ast3[]={ 0x70, 0xDC, 0xAE, 0xFB, 0x5D, 0x76, 0x1C, 0x0};
static unsigned char ast4[]={ 0xE, 0x1F, 0x2D, 0x7E, 0xBE, 0xF6, 0x7C, 0x30};




//scroll function down from ExtGraph. Download @ tict.ticalc.org
void ScrollDown160(unsigned short* buffer,unsigned short lines) {
    register short* dest = buffer;
    register short* src;
    register short  tmplines  = lines;

    dest += (tmplines<<4) - (tmplines) - 5;
    src   = dest - 15;

    tmplines -= 2;

    asm volatile (
       "0:
        move.l -(%0),-(%1);move.l -(%0),-(%1);move.l -(%0),-(%1)
        move.l -(%0),-(%1);move.l -(%0),-(%1)
        suba.w #10,%0
        suba.w #10,%1
        dbra %2,0b
        clr.l -(%1);clr.l -(%1);clr.l -(%1);clr.l -(%1);clr.l -(%1)"
        : "=a" (src), "=a" (dest), "=d" (tmplines)
        : "0"  (src), "1"  (dest), "2"  (tmplines));
}



int get_pixel(int x,int y)  // Faster replacement for GetPix from TIOS
{
  return !!(peek(0x4c00+30*y+(x>>3))&(1<<(~x&7)));
}

/*void invert_scr(void)
{
  register long *ptr;
  for(ptr=(long*)0x4c00;(unsigned long)ptr<=0x57b8;*ptr++^=-1);
}*/


//put sprite and return if there is collision between any pixel
int put_sprite(int x,int y,int sprite[])
{
  register long addr=0x4c00+30*y+((x>>3)&0xfffe),colision=0,data;
  register int i,cnt=16-(x&15);
  for(i=0;i<=15;i++,addr+=30)
    colision|=((data=(long)sprite[i]<<cnt)&peek_l(addr)),*(long*)addr^=data;
  return !colision;
}

/*int put_sprite2(int x,int y,int sprite[])
{
  register long addr=0x4c00+30*y+((x>>3)&0xfffe),colision=0,data;
  register int i,cnt=16-(x&15);
  for(i=0;i<=7;i++,addr+=30)
    colision|=((data=(long)sprite[i]<<cnt)&peek_l(addr)),*(long*)addr^=data;
  return !colision;
}*/


int random(int x)           // Returns a random number between 0 and x-1
{
  return ((rand_seed=(75*rand_seed+1))>>4)%x;
}

void randomize(unsigned int x)
{
  rand_seed=x;
}

void draw_border(void)
{
  int i;
  ClrScr();
  for(i=0;i<=4;i+=2)
    DrawClipRect(MakeWinRect(i,i,159-i,99-i),&screen_area,A_NORMAL);
}



/***********************/
/***********************/
/***********************/
//        GAME    ///////
/***********************/
/***********************/
/***********************/


long game()        // Main game; returns score
{


  int x,y,old_x,old_y,i,key,lives,crash;
  unsigned long score=0;
  int astr[6];	//stores asteriod data
  int n = 1;
	int loop=0;
int level = 0;



	astr[0]=0;

	//get level #
	if(level == '0') level = 0;
	else if(level == '1') level = 1;
	else if(level == '2') level = 2;
	else if(level == '3') level = 3;
  	else if(level == '4') level = 4;
	else if(level == '5') level = 5;




  ClrScr();
  OSSetSR(0x0400);          // Disable interrupts below Auto-Int 5


 CutScreen();	//screen special effect

 ClrScr();
 FontSetSys(F_4x6);


 	OSFreeTimer(6);
      	OSRegisterTimer(6,6-(land[0]-'0'));


 for(lives=5;lives>0;lives--)		//for 5 lives
    {
      ClrScr();
     //make bottom score bar
    	DrawStr(0,92,"  Score:             Ships:                       Level:",A_NORMAL);
	loop = 0;


 	DrawStr(150,92,land,A_REPLACE);

    for(i = 0; i < lives; i++)
     	Sprite8(72+7*i, 91, 8, lifeicon,LCD_MEM, SPRT_OR);


       DrawClipRect(&(WIN_RECT){0,90,159,98},&screen_area,A_NORMAL);
  	//end make bottom bar

      //place ship
      put_sprite(x=70,y=70,plane);
      crash=0;




      while(!crash)
        {

         loop++;
          if(_rowread(ESC_ROW)&ESC_KEY) return score;

         if(loop % 40 == 0)		//every 40 pixels, add more asteroids
        {	if(score>1200)	//determine # of asteriods to place
			n=6;
		else if(score>800)
			n=5;
		else if(score>500)
			n=4;
		else if(score>200)
			n=3;
		else if(score>100)
			n=2;



		for(i=0;i<n;i++)
			astr[i]=random(30)*5;	//random location of screen



         for(i=0;i<n;i++)	//choose random asteriod picture - there are 3
	{
		if(random(6) < 2)
			Sprite8(astr[i], 0, 8, ast3,LCD_MEM, SPRT_OR);
		else if(random(6) > 4)
			Sprite8(astr[i], 0, 8, ast4,LCD_MEM, SPRT_OR);
		else
			Sprite8(astr[i], 0, 8, ast2,LCD_MEM, SPRT_OR);


	}




	}



         //scroll 1 line down, from horizontal line 1 to 90 = dont scroll bottom score bar
          ScrollDown160(LCD_MEM, 90);

          printf_xy(27,92,"%ld",score);	//draw score





          put_sprite(x,y+1,plane);
          if(!put_sprite(x,y,plane))	//test for collision
            {
               expolode(x, y);	//animation
              crash=1;
            }
          while(!OSTimerExpired(6));      // Delay
          OSTimerRestart(6);
          old_x=x; old_y=y;
          key=_rowread(ARROWS_ROW);	//get keys


          	//move left, r, up, or d
         if(key&RIGHT_KEY)
         {
          	x+=xsen;
          	if(x>144)
          		x = 144;
          }
          else if(key&LEFT_KEY)
          {	x-=xsen;
          	if(x < 0)
          		x=0;
          }

          //y
          if(key&DOWN_KEY )
          {

          	y+=ysen;
          	if(y>75)
          		y =75;
          }
          else if(key&UP_KEY )
          {
          	y-=ysen;
          	if(y < 12)
          		y = 13;
          }



          //give more score if ship is moving, instead of not = more difficult
          if(old_x!=x||old_y!=y)
            {
              put_sprite(x,y,plane); put_sprite(old_x,old_y,plane);
              score++;
            }



        score+=(level+1);  //add to the score depending on what level
        }
    }


   //game is finished

  FontSetSys(F_8x10);
  gameover();



  ngetchx();	//wait for any key press
  CutScreen();
  return score;
}






//draw scores on main screen
void high_scores(HSC_ITEM hsc_table[])
{
  int i;

  FontSetSys(F_4x6);
  draw_str(85,30," -=HIGH SCORES=- ");


  for(i=0;i<=4;i++)
  { 	printf_xy(82,43+8*i,"%d. %-8s",i+1,hsc_table[i].name);
   	printf_xy(130,43+8*i,"%6ld", hsc_table[i].score);
  }


}


//get name for high score
void input_str(char *str,int x,int y,int maxlen)
{
  int i=0,key=0;
  while(key!=13)
    {
      str[i]='_'; str[i+1]=' '; str[i+2]=0;
      draw_str(x,y,str);
      key=ngetchx();
      if(key>=' '&&key<='~'&&i<maxlen) str[i++]=key;
      if(key==257&&i) i--;
    }
  str[i]=0;
}


//screen after game over if its a high score
void update_hsc(HSC_ITEM hsc_table[],unsigned long score)
{


  int i;
  for(i=4;(hsc_table[i-1].score<score)&&i;i--)
    memcpy(&hsc_table[i],&hsc_table[i-1],sizeof(HSC_ITEM));
  hsc_table[i].score=score;
  ClrScr();
  draw_border();
  FontSetSys(F_8x10);
  draw_str(35,10,"Good Flying!");
  FontSetSys(F_4x6);
  draw_str(44,30,"You made it to the");
  draw_str(47,40,"high scores list!");
  draw_str(49,60,"Enter your name");
  draw_str(42,70,"(max. 8 characters):");
  input_str(hsc_table[i].name,55,81,8);
  high_scores(hsc_table);
}






/////////////////////////
/////////////////////////
//        MAIN    ///////
/////////////////////////
/////////////////////////



void _main(void)            // Main program
{	int ret;
// static char speed[]="4";
int exit = 0;

  static HSC_ITEM hsc_table[5]={{"Joe",7500},{"Jill",6000},
    {"Jack",5000},{"Jane",4000},{"John",2500}};

 // int key=0;
 unsigned long score;
  poke(0x600017,0xFA);      // Force timer to work faster
  while(exit == 0)
   {


   FontSetSys(F_4x6);
      draw_border();
      DrawStr(113,89,"Version 1.01",A_NORMAL);
	high_scores(hsc_table);




		ret = MainMenu();	//main menu, returns choice afer user presses enter



      switch(ret)
        {
          case 1:

          CutScreen();
            if((score=game())>hsc_table[4].score)	//run the game and return score

              update_hsc(hsc_table,score);
            break;
          //case 2:
          //  high_scores(hsc_table);
          //  break;
         case 3:
            options();
            break;
         case 4:
            credits();
            break;
         case 5:	//quit game
             exit = 1;
            break;
       	}

      GKeyFlush();	//clear keyboard queue
      CutScreen();
  }
  poke(0x600017,0xB2);      // Restore normal timer speed
  GKeyFlush();  //clear keyboard queue
}





int MainMenu()
{
	int y=30;
	int tmp=0;
	int change=1;
	int key = 0;
	FontSetSys(F_8x10);


	DrawStr(23,10,"Asteroid Field",A_NORMAL);
	FontSetSys(F_6x8);


	while(key!=264)
		{
		if(change)
			{
			DrawStr(10,31," New Game",A_NORMAL);
			DrawStr(10,41,"<-Level->",A_NORMAL);
			DrawStr(10,51,"  Options",A_NORMAL);
			DrawStr(10,61,"  Credits",A_NORMAL);
			DrawStr(10,71,"     Exit",A_NORMAL);
			draw_str(72,41,land);
			for(tmp=y;tmp<=y+9;tmp++)
				DrawLine(9,tmp,70,tmp,A_XOR);
			}
		change=0;

		key=ngetchx();
		if(y == 40)
		{
			if(key==344)
			{
				if(land[0]++=='5') land[0]='1';

			}
			else if(key==338)
			{
				if(land[0]--=='1') land[0]='5';
			}
			 draw_str(72,41,land);
		}


		if(key==264)
			return 5;


		if(key==340)
			{
			change=1;
			for(tmp=y;tmp<=y+9;tmp++)
				DrawLine(9,tmp,70,tmp,A_XOR);
			y=y+10;
			}
		else if(key==337)
			{
			change=1;
			for(tmp=y;tmp<=y+9;tmp++)
				DrawLine(9,tmp,70,tmp,A_XOR);
			y=y-10;
			}


		else if(key==13)
			{
			if(y==30)
				return 1;
			if(y==40)
				return 2;
			if(y==50)
				return 3;
			if(y==60)
				return 4;
			if(y==70)
				return 5;

			}

		if(y==20) y=70;
		else if(y==80) y=30;
		}



	return 0;
}


void CutScreen()
{	//int a =1;
	int b = 1;
	int c = 160;

	for(b = 1; b < 160; b=b+2)
		{	DrawLine(b,1,b,100,A_NORMAL);
			DrawLine(c,1,c,100,A_NORMAL);
			c=c-2;
		}	c = 100;

}




void expolode(int xx, int yy)
{
	int delay = 400;
	int i=0;

		for( i = 0; i < delay; i++)
		{	Sprite16(xx, yy, 16, shipd1,LCD_MEM, SPRT_XOR);
			if(i%50==0)
			ScrollDown160(LCD_MEM, 90);
		}
		for( i = 0; i < delay; i++)
		{	Sprite16(xx, yy, 16, shipd2,LCD_MEM, SPRT_XOR);
			if(i%50==0)
			ScrollDown160(LCD_MEM, 90);
		}
		for( i = 0; i < delay; i++)
		{	Sprite16(xx, yy, 16, shipd3,LCD_MEM, SPRT_XOR);
			if(i%50==0)
			ScrollDown160(LCD_MEM, 90);
		}
		for( i = 0; i < delay; i++)
			Sprite16(xx, yy, 16, shipd4,LCD_MEM, SPRT_XOR);
		for( i = 0; i < delay; i++)
			Sprite16(xx, yy, 16, shipd5,LCD_MEM, SPRT_XOR);

		for( i = 0; i < delay; i++)
			Sprite16(xx, yy, 16, shipd6,LCD_MEM, SPRT_XOR);


			for( i = 0; i < delay; i++)
			Sprite16(xx, yy, 16, shipd1,LCD_MEM, SPRT_XOR);






}



void credits()
{

  ClrScr();
  draw_border();
  FontSetSys(F_8x10);
  draw_str(35,10,"Credits");
  FontSetSys(F_4x6);
  draw_str(10,40,"Programming by RipperR6");
  draw_str(10,48,"Email: ripperr6@yahoo.com");
  draw_str(10,56,"Download: http://www.ticalc.org");
  DrawStr(57,81,"Press ESC.",A_NORMAL);

 	ngetchx();
}

void options()
{
	int y=30;
	int tmp=0;
		int change=1;
	int key = 0;

 ClrScr();
  draw_border();
	 FontSetSys(F_8x10);
  draw_str(35,10,"Options");
  FontSetSys(F_4x6);

	while(key!=264)
		{
		if(change)
			{
			DrawStr(70,23,"Use <- and -> to change",A_NORMAL);
			DrawStr(40,81,"Press ESC when finished.",A_NORMAL);

			DrawStr(8,32,"Left/Right Sensitivity:",A_NORMAL);
			DrawStr(8,42,"  Up/Down Sensitivity:",A_NORMAL);
			DrawStr(50,52,"Contrast:",A_NORMAL);

			printf_xy(100,32,"%d",xsen);
			printf_xy(100,42,"%d",ysen);
			printf_xy(100,52,"<-/->" );

			for(tmp=y;tmp<=y+9;tmp++)
				DrawLine(6,tmp,90,tmp,A_XOR);
			}
		change=0;

		key=ngetchx();
		if(y == 30)
		{	if(key==344)
			{
				if(xsen++==5) xsen=1;

			}
			else if(key==338)
			{
				if(xsen--==1) xsen=5;
			}
			printf_xy(100,32,"%d",xsen);
		}

		else if(y == 40)
		{	if(key==344)
			{
				if(ysen++==5) ysen=1;

			}
			else if(key==338)
			{
				if(ysen--==1) ysen=5;
			}
			printf_xy(100,42,"%d",ysen);
		}

		else if(y == 50)
		{
			if(key==344)
			{
				OSContrastUp();

			}
			else if(key==338)
			{
				OSContrastDn();
			}



		}

		if(key==340)
		{
		change=1;
		for(tmp=y;tmp<=y+9;tmp++)
			DrawLine(6,tmp,90,tmp,A_XOR);
		y=y+10;
		}
		else if(key==337)
			{
			change=1;
			for(tmp=y;tmp<=y+9;tmp++)
				DrawLine(6,tmp,90,tmp,A_XOR);
			y=y-10;
			}


		if(y==20) y=50;
		else if(y==60) y=30;
		}

}




void gameover()
{

	DrawClipRect(&(WIN_RECT){36,41,116,56},&screen_area,A_NORMAL);
  DrawClipRect(&(WIN_RECT){34,39,118,58},&screen_area,A_NORMAL);
  draw_str(40,45,"GAME OVER");



}



//end of file
